// EmonLibrary examples openenergymonitor.org, Licence GNU GPL V3
#include "EmonLib.h"                   // Include Emon Library
//#include <TimerOne.h>
#include <MsTimer2.h>
#include <OneWire.h>
#include <DallasTemperature.h>
#include <XBee.h>
EnergyMonitor emon1;                   // Create an instance
EnergyMonitor emon2;                   // Create an instance
EnergyMonitor emon3;                   // Create an instance
int negativo = 0;
int positivo = 1; 
int semiciclo = negativo ;
double frequenciadaRede = 12 ;
double temperatura = 25 ;
double Vrms1 = 0;
double Vrms2 = 0;
double Vrms3 = 0;
double Irms1 = 0;
double Irms2 = 0;
double Irms3 = 0;
double tempoSemicicloPositivo = 0 ;  //inicializa a variavel que armazena o periodo de cada semiciclo para controle do disparo
double tempoSemicicloNegativo = 0 ;  //inicializa a variavel que armazena o periodo de cada semiciclo para controle do disparo
unsigned long microsRisingAnterior = 0 ;  //variavel que armazena o momento da passagem anterior do AC em zero volts para calcular a frequencia da rede
unsigned long microsFallingAnterior = 0 ;  //variavel que armazena o momento da passagem anterior do AC em zero volts para calcular a frequencia da rede
unsigned long lastZeroCrossInt = 0;  //variavel que armazena momento da ultima zerocrossInt

#define ONE_WIRE_BUS 3  // Data wire is plugged into port 2 on the Arduino
OneWire oneWire(ONE_WIRE_BUS);  // Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
DallasTemperature sensors(&oneWire);  // Pass our oneWire reference to Dallas Temperature.

XBee xbee = XBee();
// allocate 32 bytes for to hold all messurements
uint8_t payload[32] = {};

// 16-bit addressing: Enter address of remote XBee, typically the coordinator
Tx16Request tx = Tx16Request(255, payload, sizeof(payload));
TxStatusResponse txStatus = TxStatusResponse();

void setup(){  
  Serial.begin(19200);
  xbee.setSerial(Serial);  // inicializa porta serial para comunicacao com XBee
  emon1.current(0, 27.31);             // Current: input pin, calibration.
  emon2.current(1, 27.27);             // Current: input pin, calibration.
  emon3.current(2, 27.31);             // Current: input pin, calibration.
  emon1.voltage(3, 261.79, 1.7);      // Voltage: input pin, calibration, phase_shift
  emon2.voltage(4, 262.21, 1.7);      // Voltage: input pin, calibration, phase_shift
  emon3.voltage(5, 262.28, 1.7);      // Voltage: input pin, calibration, phase_shift
  attachInterrupt(0, zeroCrossInterrupt,RISING);  //associa interrupcao INT0 com funcao "zeroCrossInterrupt"
  MsTimer2::set(5000, calcula_frequencia); // 500ms period
  MsTimer2::start();
  sensors.begin();  // Start up the library
}
void loop(){
  emon1.calcVI(20,2000);         // Calculate all. No.of half wavelengths (crossings), time-out
  Vrms1 = emon1.Vrms;
  byte * V1 = (byte *) &Vrms1;
  payload[0]=V1[0];
  payload[1]=V1[1];
  payload[2]=V1[2];
  payload[3]=V1[3];
  
  Irms1 = emon1.calcIrms(1480);    // Calculate Irms only
  char I1[sizeof(Irms1)];
  memcpy (I1, &Irms1, sizeof(Irms1));
  payload[4]=I1[0];
  payload[5]=I1[1];
  payload[6]=I1[2];
  payload[7]=I1[3];
  
  emon2.calcVI(20,2000);         // Calculate all. No.of half wavelengths (crossings), time-out
  Vrms2 = emon2.Vrms;
  char V2[sizeof(Vrms2)];
  memcpy (V2, &Vrms2, sizeof(Vrms2));
  payload[8]=V2[0];
  payload[9]=V2[1];
  payload[10]=V2[2];
  payload[11]=V2[3];
  
  Irms2 = emon2.calcIrms(1480);    // Calculate Irms only
  char I2[sizeof(Irms2)];
  memcpy (I2, &Irms2, sizeof(Irms2));
  payload[12]=I2[0];
  payload[13]=I2[1];
  payload[14]=I2[2];
  payload[15]=I2[3];
  
  emon3.calcVI(20,2000);         // Calculate all. No.of half wavelengths (crossings), time-out
  Vrms3 = emon3.Vrms;
  char V3[sizeof(Vrms3)];
  memcpy (V3, &Vrms3, sizeof(Vrms3));
  payload[16]=V3[0];
  payload[17]=V3[1];
  payload[18]=V3[2];
  payload[19]=V3[3];

  Irms3 = emon3.calcIrms(1480);    // Calculate Irms only
  char I3[sizeof(Irms3)];
  memcpy (I3, &Irms3, sizeof(Irms3));
  payload[20]=I3[0];
  payload[21]=I3[1];
  payload[22]=I3[2];
  payload[23]=I3[3];

  char F[sizeof(frequenciadaRede)];
  memcpy (F, &frequenciadaRede, sizeof(frequenciadaRede));
  payload[24]=F[0];
  payload[25]=F[1];
  payload[26]=F[2];
  payload[27]=F[3];
  
  char T[sizeof(temperatura)];
  memcpy (T, &temperatura, sizeof(temperatura));
  payload[28]=T[0];
  payload[29]=T[1];
  payload[30]=T[2];
  payload[31]=T[3];
  
  Xbee_Send();
  delay(3000);
}
